function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';

class IndividualElement extends React.Component {
  constructor(...args) {
    super(...args);

    _defineProperty(this, "state", {
      Comp: undefined
    });

    _defineProperty(this, "componentIsUnmounted", false);
  }

  async componentDidMount() {
    const {
      describe,
      fieldProps
    } = this.props;
    const Component = await import(`./fields/${describe.type}${fieldProps.displayType ? `/${fieldProps.displayType}` : ''}`);
    const validate = !fieldProps.displayType ? await import(`./fields/${describe.type}/validation`) : undefined;
    const validation = validate ? validate.default(describe) : undefined;
    const validateOnChange = validate ? validate.validateOnChange : false;
    const validateOnBlur = validate ? validate.validateOnBlur : false;
    const comp = {
      component: Component.default,
      validation,
      validateOnChange,
      validateOnBlur
    };
    this.setComponentToState(comp);
  }

  componentWillUnmount() {
    this.componentIsUnmounted = true;
  }

  setComponentToState(Comp) {
    if (!this.componentIsUnmounted) {
      this.setState({
        Comp
      });
    }
  }

  render() {
    const {
      describe,
      fieldProps,
      layout,
      onChange,
      onBlur,
      forceOpen,
      onClose,
      autoFocus,
      rightJustifyNumeric
    } = this.props;
    const {
      Comp
    } = this.state;

    if (!Comp) {
      return React.createElement("svg", {
        width: "100%",
        height: fieldProps.svgHeight / 2,
        style: {
          paddingTop: fieldProps.svgHeight / 4,
          paddingBottom: fieldProps.svgHeight / 4
        }
      }, React.createElement("rect", {
        rx: "10",
        ry: "10",
        width: "100%",
        height: "100%",
        style: {
          opacity: 0.15
        }
      }), "Loading...");
    }

    return React.createElement(Comp.component, _extends({}, fieldProps, {
      forceOpen: forceOpen,
      onClose: onClose,
      onChange: onChange || fieldProps.onChange,
      onBlur: onBlur || fieldProps.onBlur,
      autoFocus: autoFocus,
      rightJustifyNumeric: rightJustifyNumeric,
      field: describe.name,
      layout: layout,
      describe: describe,
      validate: Comp.validation,
      validateOnChange: Comp.validateOnChange == null && true,
      validateOnBlur: Comp.validateOnBlur == null && true
    }));
  }

}

export default IndividualElement;