import React, { useEffect, useState, lazy, Suspense } from 'react';

const TableCell = ({
  describe,
  value,
  language,
  currencyCode
}) => {
  const [component, setComponent] = useState();
  useEffect(() => {
    const type = describe.type;
    const Comp = lazy(() => import(`./fields/${type}/tableCell`));
    setComponent(React.createElement(Comp, {
      describe: describe,
      value: value,
      language: language,
      currencyCode: currencyCode
    }));
  }, [describe, value]);
  return React.createElement(Suspense, {
    fallback: React.createElement("svg", {
      width: "100%",
      height: 24,
      style: {
        paddingTop: 12,
        paddingBottom: 12
      }
    }, React.createElement("rect", {
      rx: "10",
      ry: "10",
      width: "100%",
      height: "100%",
      style: {
        opacity: 0.15
      }
    }), "Loading...")
  }, component);
};

export default TableCell;