import React from 'react';
import { withFormState } from 'informed';
import DisplayContainer from '../../utils/DisplayContainer';

const AddressDisplay = ({
  formState,
  describe,
  svgHeight,
  xsLength,
  apiKey
}) => {
  const {
    values
  } = formState;
  const {
    name,
    label
  } = describe;
  const address = values[name] || {};
  const street = address.street || '';
  const city = address.city || '';
  const state = address.state || '';
  const postalCode = address.postalCode || '';
  const iFrame = React.createElement("iframe", {
    title: `${street}, ${city}, ${state} ${postalCode}`,
    width: "100%",
    height: "200",
    frameBorder: "0",
    style: {
      border: 0
    },
    src: `https://www.google.com/maps/embed/v1/place?key=${apiKey}&q=${street.replace(/ /g, '+')},+${city.replace(/ /g, '+')},+${state.replace(/ /g, '+')}+${postalCode.replace(/ /g, '+')}`,
    allowFullScreen: true
  });
  return React.createElement(DisplayContainer, {
    title: label,
    description: iFrame,
    svgHeight: svgHeight,
    xsLength: xsLength
  });
};

export default withFormState(AddressDisplay);