function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import { asField } from 'informed';
import Checkbox from '@material-ui/core/Checkbox';
import FormControl from '@material-ui/core/FormControl';
import FormControlLabel from '@material-ui/core/FormControlLabel';
import FormHelperText from '@material-ui/core/FormHelperText';

const BooleanFieldItem = (_ref) => {
  let {
    fieldState,
    fieldApi,
    describe,
    t,
    i18n,
    noRequired,
    isNewItem
  } = _ref,
      props = _objectWithoutProperties(_ref, ["fieldState", "fieldApi", "describe", "t", "i18n", "noRequired", "isNewItem"]);

  const {
    value,
    pristine,
    error
  } = fieldState;
  const {
    setValue,
    setTouched
  } = fieldApi;
  const {
    onChange,
    onBlur
  } = props;
  const {
    name,
    type,
    label,
    nillable,
    createable,
    // createable and updateable determine if the field is enabled.
    updateable,
    defaultValue,
    extraTypeInfo,
    // e.g text area and rich text area are about the same. This would say rich text area to differentiate
    deprecatedAndHidden // if this is true this component should not return anything. - Grid

  } = describe;
  let disabled = false;

  if (isNewItem && !createable) {
    disabled = true;
  }

  if (!isNewItem && !updateable) {
    disabled = true;
  }

  if (createable == null && updateable == null) {
    disabled = false;
  }

  const errors = error && !!error.length;
  const helperText = errors ? error.map(e => t(e)).join(', ') : null;
  const val = !value && value !== false ? undefined : value; // if (pristine && isNewItem) { val = defaultValue }

  return React.createElement(FormControl, {
    fullWidth: true
  }, React.createElement(FormControlLabel, {
    disabled: disabled,
    required: !nillable,
    control: React.createElement(Checkbox, {
      disabled: disabled,
      color: "primary",
      checked: !!val,
      name: name,
      required: !nillable && !disabled && !noRequired,
      onChange: e => {
        setValue(e.target.checked);
        setTouched(e.target.checked);

        if (onChange) {
          onChange(e.target.value, e, describe);
        }
      } // indeterminate={val == null}

    }),
    label: `${label}${!nillable && !disabled && !noRequired ? '*' : ''}`,
    style: {
      marginLeft: 0
    }
  }), helperText && React.createElement(FormHelperText, {
    error: errors
  }, helperText));
};

export default asField(BooleanFieldItem);

function changeHandler(currentValue) {
  if (currentValue) {
    return false;
  }

  if (currentValue == null) {
    return true;
  }

  return null;
}