import { DateTime } from 'luxon';
export default function toString(value, format) {
  let dt;

  if (typeof value === 'string') {
    value = value.replace('Z', '+00:00');
    dt = DateTime.fromISO(value);
  } else if (DateTime.isDateTime(value)) {
    dt = value;
  } else {
    dt = DateTime.fromJSDate(value);
  }

  if (!format) return dt.toLocal().toISODate();
  return dt.toLocal().toLocaleString(format);
}