import React from 'react';
import { Scope } from 'informed';
import FormElements from '../../FormElements';

const datetimeRangeFilterField = ({
  classes,
  describe,
  t,
  i18n,
  isNewItem,
  spacing,
  shrink,
  underline,
  noWrap,
  svgHeight,
  lookup,
  lookupQry
}) => {
  const {
    fields,
    name
  } = describe;
  const roleOrder = ['start', 'end'];
  const newDescribe = fields.slice().sort((a, b) => {
    return roleOrder.indexOf(a.role) - roleOrder.indexOf(b.role);
  });
  const childFields = React.createElement(FormElements, {
    classes: classes,
    columns: 1,
    describe: {
      fields: newDescribe
    },
    t: t,
    i18n: i18n,
    isNewItem: isNewItem,
    spacing: spacing,
    shrink: shrink,
    underline: underline,
    noWrap: noWrap,
    svgHeight: svgHeight,
    lookup: lookup,
    lookupQry: lookupQry,
    displayType: "filter",
    onFormLoad: () => null
  });
  return React.createElement(Scope, {
    scope: name
  }, childFields);
};

export default datetimeRangeFilterField;