function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import { DateTime } from 'luxon';
import { withFormApi } from 'informed';
import FormElements from '../../FormElements';

const noop = () => {};

class DatetimeRange extends React.Component {
  constructor(props) {
    super(props);
    this.handleChange = this.handleChange.bind(this);
  } // Hijack the change events for the sub fields
  // Reset the sibling so that if validation passes it also gets set
  // TODO automatically set the other date.


  handleChange(value, event, field) {
    const {
      formApi,
      describe,
      onChange = noop,
      onBlur = noop
    } = this.props;
    const {
      defaultDuration = 60 * 60 * 1000
    } = describe;
    const index = describe.fields.findIndex(f => f.name === field.name); // Set the sibling to re-run validation and save if needed.

    const siblingIndex = index === 0 ? 1 : 0;
    const siblingName = describe.fields[siblingIndex].name;
    let siblingValue = formApi.getState().values[siblingName];

    if (siblingIndex === 1) {
      if (DateTime.fromISO(siblingValue) < value) {
        siblingValue = value.plus({
          milliseconds: defaultDuration
        });
      }
    }

    formApi.setValue(field.name, value);
    formApi.setValue(siblingName, siblingValue);
    onChange(value, event, field);
    onBlur(value, event, field);
    onChange(siblingValue, event, _objectSpread({}, field, {
      name: siblingName
    }));
    onBlur(siblingValue, event, _objectSpread({}, field, {
      name: siblingName
    }));
  }

  render() {
    return React.createElement(FormElements, _extends({
      columns: 1,
      onFormLoad: () => null
    }, this.props, {
      onChange: this.handleChange,
      onBlur: this.handleChange
    }));
  }

}

export default withFormApi(DatetimeRange);