import React from 'react';
import { withFormState } from 'informed';
import DisplayContainer from '../../utils/DisplayContainer';

const DoubleDisplay = ({
  t,
  i18n,
  formState,
  describe,
  currencyCode,
  svgHeight,
  xsLength
}) => {
  const {
    values
  } = formState;
  const {
    name,
    label,
    type
  } = describe;
  const val = values[name];
  return React.createElement(DisplayContainer, {
    title: label,
    description: toDisplay({
      value: val,
      language: i18n.language,
      type,
      currencyCode
    }),
    svgHeight: svgHeight,
    xsLength: xsLength
  });
};

export default withFormState(DoubleDisplay);
export function toDisplay({
  value,
  language,
  type,
  currencyCode = 'USD'
}) {
  const localeType = type !== 'decimal' && type !== 'percent' && type !== 'currency' ? 'decimal' : type;

  if (!value) {
    return null;
  }

  return value.toLocaleString(language, {
    maximumFractionDigits: 20,
    style: localeType,
    currency: currencyCode,
    currencyDisplay: 'symbol'
  });
}