import React from 'react';
import Typography from '@material-ui/core/Typography';

const TableCellDouble = ({
  value,
  describe,
  language,
  currencyCode
}) => {
  const type = describe ? describe.type : undefined;
  const val = toDisplay({
    value,
    language,
    type,
    currencyCode
  });
  return React.createElement(Typography, {
    variant: "body1",
    noWrap: true,
    style: {
      textOverflow: 'ellipsis',
      overflow: 'hidden'
    }
  }, val);
};

export default TableCellDouble;

function toDisplay({
  value,
  language = 'en-US',
  type,
  currencyCode = 'USD'
}) {
  const localeType = type !== 'decimal' && type !== 'percent' && type !== 'currency' ? 'decimal' : type;

  if (!value) {
    return null;
  }

  return value.toLocaleString(language, {
    maximumFractionDigits: 20,
    style: localeType,
    currency: currencyCode,
    currencyDisplay: 'symbol'
  });
}