import React from 'react';
import { withFormState } from 'informed';
import DisplayContainer from '../../utils/DisplayContainer';

const EmailDisplay = ({
  formState,
  describe,
  svgHeight,
  xsLength
}) => {
  const {
    values
  } = formState;
  const {
    name,
    label
  } = describe;
  return React.createElement(DisplayContainer, {
    title: label,
    description: values[name] ? React.createElement("a", {
      href: `mailto:${values[name]}`,
      target: "_top"
    }, values[name]) : undefined,
    svgHeight: svgHeight,
    xsLength: xsLength
  });
};

export default withFormState(EmailDisplay);