import isMongoId from 'validator/lib/isMongoId';
import validationString from '../string/validation';
export default (describe => value => {
  const errors = validationString(describe)(value) || [];

  if (value && describe.extraTypeInfo === 'mongodb' && !isMongoId(`${value}`)) {
    errors.push('err::invalid_mongoitemId');
  }

  if (value && describe.extraTypeInfo === 'sfdx' && (value.length < 15 || value.length > 18)) {
    errors.push('err::invalid_sfdxitemId');
  }

  return errors.length ? errors : null;
});