import React from 'react';
import { withFormState } from 'informed';
import DisplayContainer from '../../utils/DisplayContainer';

const MultipicklistDisplay = ({
  formState,
  describe,
  svgHeight,
  xsLength
}) => {
  const {
    values
  } = formState;
  const {
    name,
    label
  } = describe;
  let val = '';

  if (values[name] && values[name].length) {
    val = Array.isArray(values[name]) ? values[name].sort().join(', ') : values[name].replace(';', ', ');
  }

  return React.createElement(DisplayContainer, {
    title: label,
    description: val,
    svgHeight: svgHeight,
    xsLength: xsLength
  });
};

export default withFormState(MultipicklistDisplay);