function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { useState } from 'react';
import { makeStyles } from '@material-ui/styles';
import FormControl from '@material-ui/core/FormControl'; // import Select from '@material-ui/core/Select'

import MenuItem from '@material-ui/core/MenuItem';
import Checkbox from '@material-ui/core/Checkbox';
import Grid from '@material-ui/core/Grid';
import { asField } from 'informed';
import NoSsr from '@material-ui/core/NoSsr';
import Select from 'react-select';
import CreatableSelect from 'react-select/lib/Creatable';
import classNames from 'classnames';
import Typography from '@material-ui/core/Typography';
import TextField from '@material-ui/core/TextField';
import Paper from '@material-ui/core/Paper';
import Chip from '@material-ui/core/Chip';
import CancelIcon from '@material-ui/icons/Cancel';
import FilterFieldContainer from '../../utils/FilterFieldContainer';
import picklistDropdownItems from '../../utils/picklistDropdownItems';
const useClasses = makeStyles(theme => {
  return {
    root: {
      flexGrow: 1,
      height: 250
    },
    input: {
      '&&': {
        // This bumps the specificity
        display: 'flex',
        padding: '0 0 2px 0',
        height: 'auto'
      }
    },
    valueContainer: {
      display: 'flex',
      flexWrap: 'wrap',
      flex: 1,
      alignItems: 'center',
      overflow: 'hidden'
    },
    chip: {// margin: `${theme.spacing(1) / 2}px ${theme.spacing(1) / 4}px`,
    },
    chipFocused: {// backgroundColor: emphasize(
      // theme.palette.type === 'light' ? theme.palette.grey[300] : theme.palette.grey[700],
      // 0.08,
      // ),
    },
    noOptionsMessage: {// padding: `${theme.spacing(1)}px ${theme.spacing(1) * 2}px`,
    },
    singleValue: {
      fontSize: 16
    },
    placeholder: {
      position: 'absolute',
      left: 2,
      fontSize: 16
    },
    paper: {
      position: 'absolute',
      zIndex: 1,
      // marginTop: theme.spacing(1),
      left: 0,
      right: 0,
      minWidth: 240
    },
    divider: {// height: theme.spacing(2),
    }
  };
});
const filters = {
  Any: [{
    type: 'SelectField',
    label: 'Any',
    key: '$any'
  }],
  All: [{
    type: 'SelectField',
    label: 'All',
    key: '$all'
  }],
  Exclude: [{
    type: 'SelectField',
    label: 'Exclude',
    key: '$exclude'
  }],
  'HasAnyValue': [{
    type: 'Text',
    label: 'HasAnyValue',
    key: '$exists'
  }],
  'HasNoValue': [{
    type: 'Text',
    label: 'HasNoValue',
    key: '$exists'
  }]
};

class PicklistFilterFieldItem extends React.Component {
  constructor(...args) {
    super(...args);

    _defineProperty(this, "state", {
      filterType: this.props.fieldState.value && this.props.fieldState.value.type || 'Any',
      $any: this.props.fieldState.value && this.props.fieldState.value.$any || undefined,
      $all: this.props.fieldState.value && this.props.fieldState.value.$all || undefined,
      $exclude: this.props.fieldState.value && this.props.fieldState.value.$exclude || undefined,
      $exists: this.props.fieldState.value && this.props.fieldState.value.$exists || undefined
    });
  }

  handleSetValue() {
    this.props.fieldApi.setValue({
      type: this.state.filterType,
      $any: this.state.$any,
      $all: this.state.$all,
      $exclude: this.state.$exclude,
      $exists: this.state.$exists
    });
  }

  handleChangeFilter(filter) {
    this.setState({
      filterType: filter,
      $any: undefined,
      $all: undefined,
      $exclude: undefined,
      $exists: filter === 'HasAnyValue' || filter === 'HasNoValue' ? filter === 'HasAnyValue' : undefined
    }, () => this.handleSetValue());

    if (filter === 'HasAnyValue' || filter === 'HasNoValue') {
      this.setState({
        value: undefined
      });
    }
  }

  handleOnChange(key, value) {
    this.setState({
      [key]: value
    }, () => {
      this.handleSetValue();
    });
  }

  handleOnBlur(key, value) {
    this.props.fieldApi.setTouched();
    this.setState({
      [key]: value
    }, () => {
      this.handleSetValue();
    });
  }

  render() {
    const _this$props = this.props,
          {
      fieldState,
      fieldApi,
      describe,
      t,
      i18n,
      shrink,
      underline,
      spacing
    } = _this$props,
          props = _objectWithoutProperties(_this$props, ["fieldState", "fieldApi", "describe", "t", "i18n", "shrink", "underline", "spacing"]);

    const {
      value
    } = fieldState;
    const {
      setValue,
      setTouched
    } = fieldApi;
    const {
      onChange,
      onBlur
    } = props;
    const {
      filterType
    } = this.state;
    return React.createElement(FilterFieldContainer, {
      t: t,
      filterList: describe.type === 'picklist' ? picklistDropdownItems.filter(pi => pi !== 'All') : picklistDropdownItems,
      filterChange: filter => this.handleChangeFilter(filter)
    }, React.createElement(Grid, {
      container: true,
      spacing: spacing,
      alignItems: "flex-end"
    }, React.createElement(Grid, {
      item: true,
      xs: 4
    }, describe.label, ":"), filters[filterType] && filters[filterType].map(ft => {
      const filterColumns = filters[filterType].length > 2 ? 2 : filters[filterType].length;

      if (ft.type === 'SelectField') {
        return React.createElement(Grid, {
          item: true,
          key: ft.key,
          xs: 8 / filterColumns
        }, React.createElement(FieldItemIndividual, {
          label: t(ft.label),
          describe: describe,
          value: this.state[ft.key] ? this.state[ft.key] : '',
          onChange: value => this.handleOnChange(ft.key, value),
          onBlur: value => this.handleOnBlur(ft.key, value),
          shrink: shrink,
          underline: underline
        }));
      }

      if (ft.type === 'Text') {
        return React.createElement(Grid, {
          item: true,
          key: ft.key,
          xs: 8 / filterColumns
        }, ft.label);
      }

      return 'err::invalidFilterType';
    })));
  }

}

export default asField(PicklistFilterFieldItem);

function NoOptionsMessage(props) {
  return React.createElement(Typography, _extends({
    color: "textSecondary",
    className: props.selectProps.classes.noOptionsMessage
  }, props.innerProps), props.children);
}

function inputComponent(_ref) {
  let {
    inputRef
  } = _ref,
      props = _objectWithoutProperties(_ref, ["inputRef"]);

  return React.createElement("div", _extends({
    ref: inputRef
  }, props));
}

function Control(props) {
  return React.createElement(TextField, _extends({
    fullWidth: true,
    InputProps: {
      inputComponent,
      inputProps: _objectSpread({
        className: props.selectProps.classes.input,
        inputRef: props.innerRef,
        children: props.children
      }, props.innerProps)
    }
  }, props.selectProps.textFieldProps));
}

function Option(props) {
  return React.createElement(MenuItem, _extends({
    buttonRef: props.innerRef,
    selected: props.isFocused,
    component: "div",
    style: {
      fontWeight: props.isSelected ? 500 : 400,
      minWidth: 200
    }
  }, props.innerProps), props.isMulti && props.isSelected && React.createElement(Checkbox, {
    checked: true,
    color: "primary"
  }), props.isMulti && !props.isSelected && React.createElement(Checkbox, {
    checked: false,
    color: "primary"
  }), props.children);
}

function Placeholder(props) {
  return React.createElement(Typography, _extends({
    color: "textSecondary",
    className: props.selectProps.classes.placeholder
  }, props.innerProps), props.children);
}

function SingleValue(props) {
  return React.createElement(Typography, _extends({
    className: props.selectProps.classes.singleValue
  }, props.innerProps), props.children);
}

function ValueContainer(props) {
  return React.createElement("div", {
    className: props.selectProps.classes.valueContainer
  }, props.children);
}

function MultiValue(props) {
  return React.createElement(Chip, {
    tabIndex: -1,
    label: props.children,
    className: classNames(props.selectProps.classes.chip, {
      [props.selectProps.classes.chipFocused]: props.isFocused
    }),
    onDelete: props.removeProps.onClick,
    deleteIcon: React.createElement(CancelIcon, props.removeProps)
  });
}

function Menu(props) {
  return React.createElement(Paper, _extends({
    square: true,
    className: props.selectProps.classes.paper
  }, props.innerProps), props.children);
}

const components = {
  Control,
  Menu,
  MultiValue,
  NoOptionsMessage,
  Option,
  Placeholder,
  SingleValue,
  ValueContainer
};

function FieldItemIndividual({
  label,
  value,
  onChange,
  onBlur,
  describe,
  shrink,
  underline
}) {
  const classes = useClasses();
  const [hasFocus, setHasFocus] = useState(false);
  const {
    name,
    type,
    // label,
    length,
    // may be used for fullWidth - In the grid component?
    nillable,
    encrypted,
    bytelength,
    createable,
    // createable and updateable determine if the field is enabled.
    updateable,
    defaultValue,
    extraTypeInfo,
    // e.g text area and rich text area are about the same. This would say rich text area to differentiate
    picklistValues = [],
    inlineHelpText,
    deprecatedAndHidden // if this is true this component should not return anything. - Grid

  } = describe;
  let val = !value && value !== 0 ? '' : value;

  if (val === null) {
    val = [];
  }

  if (!Array.isArray(val)) {
    val = val.split(';').map(v => picklistValues.find(pv => pv.value === v)).filter(v => v);
  } else {
    val = val.map(v => {
      if (typeof v === 'string') {
        return picklistValues.find(pv => pv.value === v);
      }

      return v;
    }).filter(v => v);
  }

  const shrinkLabel = hasFocus || (type === 'multipicklist' ? !!(shrink || val.length) : !!(shrink || val));

  function handleChangeMulti(selectedOptions, action) {
    // const stringVersion = selectedOptions.map(r => r.value).join(';').trim(';')
    // setValue(stringVersion)
    // setTouched()
    if (onChange) {
      onChange(selectedOptions.map(r => r.value));
    }

    if (onBlur) {
      onBlur(selectedOptions.map(r => r.value));
    } // if (onChange) { onChange(stringVersion, fakeEvent(action, stringVersion), describe) }
    // if (onBlur) { onBlur(stringVersion, fakeEvent(action, stringVersion), describe) }

  }

  const selectStyles = {
    input: base => _objectSpread({}, base, {
      // color: theme.palette.text.primary,
      '& input': {
        font: 'inherit'
      }
    })
  };
  const Comp = type === 'combobox' ? CreatableSelect : Select;
  return React.createElement(FormControl, {
    fullWidth: true
  }, React.createElement(NoSsr, null, React.createElement(Comp, {
    isClearable: true,
    isSearchable: true,
    hideSelectedOptions: false,
    closeMenuOnSelect: false,
    classes: classes,
    styles: selectStyles,
    options: picklistValues,
    components: components,
    value: val,
    onChange: handleChangeMulti,
    onFocus: () => setHasFocus(true),
    onBlur: () => setHasFocus(false),
    isMulti: true,
    placeholder: "",
    name: name,
    textFieldProps: {
      label,
      InputLabelProps: {
        shrink: shrinkLabel
      }
    }
  })));
}