function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import Promise from 'bluebird';
import debounce from 'lodash/fp/debounce';
import isEqual from 'lodash/fp/isEqual';
import unset from 'lodash/fp/unset';
Promise.config({
  cancellation: true
});
const unsetter = unset('lookupQry');

class QueryManager extends React.Component {
  constructor(...args) {
    super(...args);

    _defineProperty(this, "state", {
      data: undefined,
      loading: false,
      error: false
    });

    _defineProperty(this, "currentCancellableRequest", null);

    _defineProperty(this, "dataBackFromRequest", data => {
      const backToNull = {
        label: this.props.nullLabel || 'None',
        itemId: null,
        Id: null
      };
      this.currentCancellableRequest = null;
      this.setState({
        data: [backToNull, ...data],
        error: false,
        loading: false
      });
    });

    _defineProperty(this, "requestFailed", err => {
      this.setState({
        data: undefined,
        error: err.message,
        loading: false
      });
      console.error(err);
    });

    _defineProperty(this, "makeNetworkRequest", debounce(300)(() => {
      const {
        fieldName,
        lookupQry,
        itemTypes,
        inputValue
      } = this.props;
      this.currentCancellableRequest = new Promise((res, rej) => lookupQry({
        fieldName,
        itemType: itemTypes,
        value: inputValue
      }).then(res).catch(rej)).then(this.dataBackFromRequest).catch(this.requestFailed);
    }));

    _defineProperty(this, "fetchData", () => {
      this.setState({
        loading: true
      });
      this.makeNetworkRequest();
    });
  }

  componentDidMount() {
    this.fetchData();
  }

  componentDidUpdate(_ref) {
    let {
      children: _
    } = _ref,
        prevProps = _objectWithoutProperties(_ref, ["children"]);

    const _this$props = this.props,
          {
      children
    } = _this$props,
          props = _objectWithoutProperties(_this$props, ["children"]);

    if (!isEqual(unsetter(prevProps), unsetter(props))) {
      this.fetchData();
    }
  }

  componentWillUnmount() {
    if (this.currentCancellableRequest) {
      this.currentCancellableRequest.cancel();
    }
  }

  render() {
    const {
      children
    } = this.props;
    const {
      data,
      loading,
      error
    } = this.state;
    return children({
      data,
      loading,
      error,
      refetch: this.fetchData
    });
  }

}

export default QueryManager;