import React from 'react';
import ListBulletedIcon from '@material-ui/icons/FormatListBulleted';
import ListNumberedIcon from '@material-ui/icons/FormatListNumbered';
import StyleButton from './StyleButton';
const BLOCK_TYPES = [// {label: 'H1', style: 'header-one' },
// {label: 'H2', style: 'header-two' },
// {label: 'H3', style: 'header-three' },
// {label: 'H4', style: 'header-four' },
// {label: 'H5', style: 'header-five' },
// {label: 'H6', style: 'header-six' },
// {label: 'Blockquote', style: 'blockquote' },
{
  label: 'UL',
  style: 'unordered-list-item',
  icon: React.createElement(ListBulletedIcon, null)
}, {
  label: 'OL',
  style: 'ordered-list-item',
  icon: React.createElement(ListNumberedIcon, null)
} // { label: 'Left', style: 'justify-left' },
// { label: 'Center', style: 'justify-center' },
// { label: 'Right', style: 'justify-right' },
// {label: 'Code Block', style: 'code-block' },
];
export default (props => {
  const {
    editorState
  } = props;
  const selection = editorState.getSelection();
  const blockType = editorState.getCurrentContent().getBlockForKey(selection.getStartKey()).getType();
  return React.createElement(React.Fragment, null, BLOCK_TYPES.map(type => React.createElement(StyleButton, {
    key: type.label,
    active: type.style === blockType,
    label: type.label,
    onToggle: props.onToggle,
    style: type.style,
    icon: type.icon
  })));
});