import React from 'react';
import BoldIcon from '@material-ui/icons/FormatBold';
import ItalicIcon from '@material-ui/icons/FormatItalic';
import UnderlineIcon from '@material-ui/icons/FormatUnderlined';
import StrikethroughIcon from '@material-ui/icons/FormatStrikethrough';
import StyleButton from './StyleButton';
const INLINE_STYLES = [{
  label: 'Bold',
  style: 'BOLD',
  icon: React.createElement(BoldIcon, null)
}, {
  label: 'Italic',
  style: 'ITALIC',
  icon: React.createElement(ItalicIcon, null)
}, {
  label: 'Underline',
  style: 'UNDERLINE',
  icon: React.createElement(UnderlineIcon, null)
}, {
  label: 'Strikethrough',
  style: 'STRIKETHROUGH',
  icon: React.createElement(StrikethroughIcon, null)
} // {label: 'Monospace', style: 'CODE' },
];
export default (props => {
  const currentStyle = props.editorState.getCurrentInlineStyle();
  const {
    t
  } = props;
  return React.createElement(React.Fragment, null, INLINE_STYLES.map(type => React.createElement(StyleButton, {
    key: type.label,
    active: currentStyle.has(type.style),
    label: t(type.label),
    onToggle: props.onToggle,
    style: type.style,
    icon: type.icon
  })));
});