import React from 'react';
import { withFormState } from 'informed';
import DisplayContainer from '../../utils/DisplayContainer';

const RichtextareaDisplay = ({
  formState,
  describe,
  svgHeight,
  xsLength
}) => {
  const {
    values
  } = formState;
  const {
    name,
    label
  } = describe;
  return React.createElement(DisplayContainer, {
    title: label,
    description: React.createElement("div", {
      dangerouslySetInnerHTML: {
        __html: values[name]
      }
    }),
    svgHeight: svgHeight,
    xsLength: xsLength
  });
};

export default withFormState(RichtextareaDisplay);