function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import { asField } from 'informed';
import RichTextarea from './RichTextarea';
export const RichtextareaFieldItem = (_ref) => {
  let {
    fieldState,
    fieldApi,
    describe,
    t,
    i18n,
    noRequired,
    isNewItem,
    maxLines,
    shrink,
    underline
  } = _ref,
      props = _objectWithoutProperties(_ref, ["fieldState", "fieldApi", "describe", "t", "i18n", "noRequired", "isNewItem", "maxLines", "shrink", "underline"]);

  const {
    value,
    pristine,
    error
  } = fieldState;
  const {
    setValue,
    setTouched
  } = fieldApi;
  const {
    onChange,
    onBlur
  } = props;
  const {
    name,
    type,
    label,
    length,
    // may be used for fullWidth - In the grid component?
    nillable,
    encrypted,
    bytelength,
    createable,
    // createable and updateable determine if the field is enabled.
    updateable,
    defaultValue,
    extraTypeInfo,
    // e.g text area and rich text area are about the same. This would say rich text area to differentiate
    inlineHelpText,
    deprecatedAndHidden // if this is true this component should not return anything. - Grid

  } = describe;
  let disabled = false;

  if (isNewItem && !createable) {
    disabled = true;
  }

  if (!isNewItem && !updateable) {
    disabled = true;
  }

  if (createable == null && updateable == null) {
    disabled = false;
  }

  const errors = error && !!error.length;
  const helperText = errors ? error.map(e => t(e)).join(', ') : null;
  const multiLine = parseInt(maxLines, 10) > 1 || false;
  const lines = parseInt(maxLines, 10) || 1;
  let val = !value && value !== 0 ? '' : value;

  if (type === 'base64') {
    val = atob(val);
  } else if (pristine && isNewItem) {
    val = defaultValue;
  }

  return React.createElement(RichTextarea, {
    t: t,
    value: val,
    label: t(label),
    disabled: disabled,
    required: !nillable && !disabled && !noRequired,
    error: !!errors,
    helperText: helperText,
    rowsMax: lines,
    onChange: htmlMarkup => {
      const newValue = type === 'base64' ? btoa(htmlMarkup) : htmlMarkup;
      setValue(newValue);

      if (onChange) {
        onChange(newValue, {}, describe);
      }
    },
    onBlur: e => {
      setTouched();

      if (onBlur) {
        onBlur(e.target.value, e, describe);
      }
    },
    shrink: shrink,
    underline: underline
  });
};
export default asField(RichtextareaFieldItem);