import React from 'react';
import { Scope } from 'informed';
import FormElements from '../../FormElements';

const scopedField = ({
  classes,
  describe,
  t,
  i18n,
  noRequired,
  isNewItem,
  spacing,
  shrink,
  underline,
  noWrap,
  svgHeight,
  lookup,
  lookupQry
}) => {
  const {
    name
  } = describe;
  const childFields = React.createElement(FormElements, {
    classes: classes,
    columns: 1,
    describe: describe,
    t: t,
    i18n: i18n,
    noRequired: noRequired,
    isNewItem: isNewItem,
    spacing: spacing,
    shrink: shrink,
    underline: underline,
    noWrap: noWrap,
    svgHeight: svgHeight,
    lookup: lookup,
    lookupQry: lookupQry,
    onFormLoad: () => null
  });
  return React.createElement(Scope, {
    scope: name
  }, childFields);
};

export default scopedField;