function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import { withFormState } from 'informed';
import DisplayContainer from '../../utils/DisplayContainer';
export class ReferenceFieldDisplay extends React.Component {
  constructor(...args) {
    super(...args);

    _defineProperty(this, "state", {});
  }

  async componentDidMount() {
    const {
      formState: {
        values
      },
      lookup,
      describe
    } = this.props;
    const value = values[describe.name];

    if (typeof lookup === 'function' && value) {
      const item = await lookup(value, describe.name, describe);

      if (item) {
        this.setState({
          item
        });
      }
    }
  }

  render() {
    const {
      item
    } = this.state;
    const {
      describe,
      svgHeight,
      xsLength
    } = this.props;
    const {
      label
    } = describe;
    let description = '';

    if (item) {
      description = item.Name;
    }

    return React.createElement(DisplayContainer, {
      title: label,
      description: description,
      svgHeight: svgHeight,
      xsLength: xsLength
    });
  }

}
export default withFormState(ReferenceFieldDisplay);