import React from 'react';
import { withFormState } from 'informed';
import formatPhone from '../../utils/phoneFormatter';
import DisplayContainer from '../../utils/DisplayContainer';

const StringDisplay = ({
  formState,
  describe,
  svgHeight,
  xsLength
}) => {
  const {
    values
  } = formState;
  const {
    name,
    label,
    type
  } = describe;
  return React.createElement(DisplayContainer, {
    title: label,
    description: type === 'phone' ? formatPhone(values[name]) : values[name],
    svgHeight: svgHeight,
    xsLength: xsLength
  });
};

export default withFormState(StringDisplay);