export default (describe => value => {
  const errors = [];

  if (describe.nillable === false && !value && value !== 0) {
    errors.push('err::required');
  }

  if (value && describe.length < value.length) {
    errors.push('err::max_length');
  }

  if (value && describe.minLength > value.length) {
    errors.push('err::min_length');
  }

  if (value && describe.regex && matchRegexString(value, describe.regex)) {
    errors.push(matchRegexString(value, describe.regex));
  }

  return errors.length ? errors : null;
});

function matchRegexString(value, regex) {
  const r = new RegExp(regex);
  if (!r.test(value)) return 'err::regex_match';
}