import React from 'react';
import { withFormState } from 'informed';
import { DateTime } from 'luxon';
import DisplayContainer from '../../utils/DisplayContainer';

const TimeDisplay = ({
  formState,
  describe,
  svgHeight,
  xsLength
}) => {
  const {
    values
  } = formState;
  const {
    name,
    label
  } = describe;
  let val = values[name];

  if (!val || val === '') {
    val = null;
  }

  if (val && val.charAt(1) === ':') {
    val = `0${val}`;
  }

  if (val) {
    val = DateTime.fromISO(val.replace('Z', '+00:00')).toLocal().toLocaleString(DateTime.TIME_SIMPLE);
  }

  return React.createElement(DisplayContainer, {
    title: label,
    description: val,
    svgHeight: svgHeight,
    xsLength: xsLength
  });
};

export default withFormState(TimeDisplay);