import React from 'react';
import { DateTime } from 'luxon';
import Typography from '@material-ui/core/Typography';

const TableCellTime = ({
  value
}) => {
  let val = value;

  if (val) {
    val = DateTime.fromISO(val.replace('Z', '+00:00')).toLocal().toLocaleString(DateTime.TIME_SIMPLE);
  }

  return React.createElement(Typography, {
    variant: "body1",
    noWrap: true,
    style: {
      textOverflow: 'ellipsis',
      overflow: 'hidden'
    }
  }, val);
};

export default TableCellTime;