import { DateTime } from 'luxon';
export default function toString(value, format = DateTime.TIME_SIMPLE) {
  let dt;

  if (typeof value === 'string') {
    value = value.replace('Z', '+00:00');
    dt = DateTime.fromISO(value);
  } else if (DateTime.isDateTime(value)) {
    dt = value;
  } else {
    dt = DateTime.fromJSDate(value);
  }

  return dt.toLocal().toLocaleString(format);
}