import React from 'react';
import { withFormState } from 'informed';
import DisplayContainer from '../../utils/DisplayContainer';

const UrlDisplay = ({
  formState,
  describe,
  svgHeight,
  xsLength
}) => {
  const {
    values
  } = formState;
  const {
    name,
    label
  } = describe;
  const image = values[name] && values[name].match(/\.(jpeg|jpg|gif|png)$/) != null;
  const value = !!values[name];
  const displayValue = image ? React.createElement("img", {
    src: values[name],
    href: values[name],
    rel: "noopener noreferrer",
    target: "_blank",
    alt: values[name],
    style: {
      maxWidth: 250,
      maxHeight: 250
    }
  }) : values[name];
  const description = value ? React.createElement("a", {
    href: values[name],
    rel: "noopener noreferrer",
    target: "_blank"
  }, displayValue) : undefined;
  return React.createElement(DisplayContainer, {
    title: label,
    description: description,
    svgHeight: svgHeight,
    xsLength: xsLength
  });
};

export default withFormState(UrlDisplay);