import React from 'react';
import Grid from '@material-ui/core/Grid';
import { withStyles } from '@material-ui/styles';
import Typography from '@material-ui/core/Typography';

const styles = theme => ({
  overflows: {
    overflow: 'auto'
  }
});

const DisplayContainer = ({
  classes,
  title,
  description,
  icon,
  svgHeight,
  xsLength
}) => {
  if (description == null) {
    return null;
  }

  return React.createElement(Grid, {
    item: true,
    xs: xsLength,
    style: {
      whiteSpace: 'inherit'
    }
  }, React.createElement(Grid, {
    container: true,
    style: {
      minHeight: svgHeight
    }
  }, icon && React.createElement(Grid, {
    item: true
  }, icon), React.createElement(Grid, {
    item: true,
    xs: true
  }, React.createElement(Grid, {
    container: true
  }, React.createElement(Grid, {
    item: true,
    xs: 12
  }, React.createElement(Typography, {
    variant: "caption",
    component: "div"
  }, title)), React.createElement(Grid, {
    item: true,
    xs: 12,
    className: classes.overflows
  }, React.createElement(Typography, {
    noWrap: true,
    variant: "body1",
    component: "div"
  }, description))))));
};

export default withStyles(styles)(DisplayContainer);