import React, { useState } from 'react';
import IconButton from '@material-ui/core/IconButton';
import MoreVert from '@material-ui/icons/MoreVert';
import Menu from '@material-ui/core/Menu';
import MenuItem from '@material-ui/core/MenuItem';

function FilterDropdownSelect({
  t,
  selected,
  filterList = [],
  filterChange
}) {
  const [anchorEl, setAnchorEl] = useState(null);

  function handleClick(event) {
    setAnchorEl(event.currentTarget);
  }

  function handleClose(event) {
    setAnchorEl(null);
  }

  return React.createElement(React.Fragment, null, React.createElement(IconButton, {
    onClick: handleClick
  }, React.createElement(MoreVert, null)), React.createElement(Menu, {
    anchorEl: anchorEl,
    open: !!anchorEl,
    onClose: handleClose
  }, filterList.map(item => React.createElement(MenuItem, {
    key: item,
    selected: selected === item,
    onClick: () => {
      filterChange(item);
      handleClose();
    }
  }, t(item)))));
}

export default FilterDropdownSelect;