export function normalize(phoneNumber) {
  return phoneNumber.replace(/\D/g, '');
}

function format(phoneNumber) {
  if (!phoneNumber) {
    return '';
  }

  const normalized = normalize(phoneNumber);

  if (normalized.length < 10) {
    return phoneNumber;
  }

  if (normalized.length > 10) {
    return formatLong(normalized);
  }

  return formatShort(normalized);
}

export default format;

function formatLong(phoneNumber) {
  const [number] = phoneNumber.match(/\d{10}$/);
  const countryCode = phoneNumber.replace(number, '');
  const match = number.match(/^(\d{3})(\d{3})(\d{4})$/);
  return `+${countryCode} (${match[1]}) ${match[2]}-${match[3]}`;
}

function formatShort(phoneNumber) {
  const match = phoneNumber.match(/^(\d{3})(\d{3})(\d{4})$/);
  return `(${match[1]}) ${match[2]}-${match[3]}`;
}