import { colors } from '@material-ui/core';
const defaultColors = Object.keys(colors).filter(k => k !== 'common' && k !== 'grey').sort();

const getColor = (value, picklistValues) => {
  const optIndex = picklistValues.findIndex(option => option.value === value);
  let color = optIndex >= 0 && picklistValues[optIndex] && picklistValues[optIndex].color && colors[picklistValues[optIndex].color];

  if (!color) {
    color = defaultColors[optIndex % defaultColors.length];
  }

  if (optIndex < 0) {
    color = 'grey';
  }

  return [colors[color][900], colors[color][100]];
};

export default getColor;